package Local;
use strict;
use ExSite::Config;

=pod

=head1 Local.pm

B<Local.pm> - shareable website localization.

C<Local.pm> contains general-purpose reusable code particular to this
ExSite installation.  By default, it is empty, and the local site 
developers can fill it with routines and functions to perform whatever
tasks the local web applications require.

Public functions used by other programs/scripts should be exported
using the C<@EXPORT> or C<@EXPORT_OK> lists.  Private functions 
(called only from within C<Local.pm>) need not be exported.

Shared resources (eg. database handles, page objects, etc.) are 
available in the C<%share> hash, imported from C<ExSite::Config>.
General site configuration information is available in C<%config>.

When upgrading ExSite, be sure you don't copy the default empty
Local.pm over your version.

=cut

# Exported Names

BEGIN {
    use Exporter;
    use vars qw(@ISA @EXPORT @EXPORT_OK %EXPORT_TAGS);
    @ISA = qw(Exporter);
    @EXPORT_OK   = ( );
    %EXPORT_TAGS = ( );
    @EXPORT      = qw(

		      );

}

use vars (@EXPORT, @EXPORT_OK);


# insert Local functions and subroutines here



# EOF

1;

