#!/usr/bin/perl
#-----------------------------------------------------------------------
# content.cgi - retrieve content from the database for viewing
#-----------------------------------------------------------------------

use strict;
use ExSite::Config;
use ExSite::DB;
use ExSite::ContentData;
use ExSite::Misc;

use vars qw($db %q);

&exsite_init;
$db = new ExSite::DB;
my %q = &DecodeQuery;

print "Content-type: text/html\n\n";
print "<HEAD>\n<TITLE>Content Preview</TITLE>\n";
print "<link REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"$config{server}{HTMLpath}/_ExSite/css/ExSite.css\">\n";
print "</HEAD>\n<BODY>\n<div align=\"center\">\n";
print "<P><A HREF=\"javascript:window.close()\" style=\"border:1px solid black; padding:4px; background-color:#CCCCFF; text-decoration:none;\">Close Window</A></P><br>\n";
if ($q{id}) {
    # authorization logic needed!!!
    my $c = new ExSite::ContentData(id=>$q{id});
    my $type = $c->content_type;
    if ($type =~ /text\/html/) {
	print $c->expand;  # show oysters
	print "<P>References to unresolved content items are displayed as a checkered 
graphic;  these items will appear only when this content is viewed as part
of a page.</P>\n";
    }
    else {
	print $c->get_html;
    }
}
else {
    print "<p>No content object specified.</p>\n";
}

print "</html>\n</body>\n";
